From 69db81496c97adb72f30d3b35f40755b75860c4a Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 26 2020 01:49:40 +0000
Subject: [PATCH 1558/2232] Move slice validation to type checker


---

diff --git a/syntax/check.rs b/syntax/check.rs
index 431aeee..0dbd45e 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -3,7 +3,7 @@ use crate::syntax::report::Errors;
 use crate::syntax::types::TrivialReason;
 use crate::syntax::{
     error, ident, Api, Array, Enum, ExternFn, ExternType, Impl, Lang, Receiver, Ref, Signature,
-    Struct, Ty1, Type, Types,
+    SliceRef, Struct, Ty1, Type, Types,
 };
 use proc_macro2::{Delimiter, Group, Ident, TokenStream};
 use quote::{quote, ToTokens};
@@ -36,7 +36,8 @@ fn do_typecheck(cx: &mut Check) {
             Type::Ref(ty) => check_type_ref(cx, ty),
             Type::Array(array) => check_type_array(cx, array),
             Type::Fn(ty) => check_type_fn(cx, ty),
-            Type::Str(_) | Type::Void(_) | Type::SliceRef(_) => {}
+            Type::SliceRef(ty) => check_type_slice_ref(cx, ty),
+            Type::Str(_) | Type::Void(_) => {}
         }
     }
 
@@ -177,6 +178,16 @@ fn check_type_ref(cx: &mut Check, ty: &Ref) {
     cx.error(ty, "unsupported reference type");
 }
 
+fn check_type_slice_ref(cx: &mut Check, ty: &SliceRef) {
+    match &ty.inner {
+        Type::Ident(ident) if ident.rust == U8 => {}
+        _ => cx.error(
+            ty,
+            "only &[u8] and &mut [u8] are supported so far, not other slice types",
+        ),
+    }
+}
+
 fn check_type_array(cx: &mut Check, ty: &Array) {
     let supported = match &ty.inner {
         Type::Str(_) | Type::SliceRef(_) => false,
diff --git a/syntax/parse.rs b/syntax/parse.rs
index 25b17fd..f1a330c 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -650,20 +650,14 @@ fn parse_type(ty: &RustType) -> Result<Type> {
 fn parse_type_reference(ty: &TypeReference) -> Result<Type> {
     if let RustType::Slice(slice) = ty.elem.as_ref() {
         let inner = parse_type(&slice.elem)?;
-        return match &inner {
-            Type::Ident(ident) if ident.rust == U8 => Ok(Type::SliceRef(Box::new(SliceRef {
-                ampersand: ty.and_token,
-                lifetime: ty.lifetime.clone(),
-                mutable: ty.mutability.is_some(),
-                bracket: slice.bracket_token,
-                inner,
-                mutability: ty.mutability,
-            }))),
-            _ => Err(Error::new_spanned(
-                ty,
-                "only &[u8] and &mut [u8] are supported so far, not other slice types",
-            )),
-        };
+        return Ok(Type::SliceRef(Box::new(SliceRef {
+            ampersand: ty.and_token,
+            lifetime: ty.lifetime.clone(),
+            mutable: ty.mutability.is_some(),
+            bracket: slice.bracket_token,
+            inner,
+            mutability: ty.mutability,
+        })));
     }
 
     let inner = parse_type(&ty.elem)?;

